{
    "$graph": [
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "coresMax": 1,
                    "ramMin": 1024,
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "mgrast/qiime:1.0.20180919",
                    "class": "DockerRequirement"
                },
                {
                    "packages": [
                        {
                            "specs": [
                                "https://identifiers.org/rrid/RRID:SCR_008249"
                            ],
                            "version": [
                                "1.9.1"
                            ],
                            "package": "qiime"
                        }
                    ],
                    "class": "SoftwareRequirement"
                }
            ],
            "stderr": "alpha_diversity.error",
            "stdout": "alpha_diversity.out",
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "default": [
                        "chao1",
                        "PD_whole_tree",
                        "shannon",
                        "observed_otus"
                    ],
                    "inputBinding": {
                        "prefix": "-m",
                        "separate": false,
                        "itemSeparator": ","
                    },
                    "id": "#alpha_diversity.cwl/method"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-i"
                    },
                    "id": "#alpha_diversity.cwl/otu-table"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--tree_path"
                    },
                    "id": "#alpha_diversity.cwl/tree"
                }
            ],
            "baseCommand": "alpha_diversity.py",
            "arguments": [
                {
                    "valueFrom": "alpha_diversity.txt",
                    "prefix": "-o"
                }
            ],
            "s:license": "https://www.apache.org/licenses/LICENSE-2.0",
            "s:copyrightHolder": "n/a",
            "id": "#alpha_diversity.cwl",
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "alpha_diversity.txt"
                    },
                    "id": "#alpha_diversity.cwl/alpha"
                },
                {
                    "type": "File",
                    "id": "#alpha_diversity.cwl/stderr",
                    "outputBinding": {
                        "glob": "alpha_diversity.error"
                    }
                },
                {
                    "type": "File",
                    "id": "#alpha_diversity.cwl/stdout",
                    "outputBinding": {
                        "glob": "alpha_diversity.out"
                    }
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "coresMax": 1,
                    "ramMin": 1024,
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "mgrast/qiime:1.0.20180919",
                    "class": "DockerRequirement"
                },
                {
                    "packages": [
                        {
                            "specs": [
                                "https://identifiers.org/rrid/RRID:SCR_008249"
                            ],
                            "version": [
                                "1.9.1"
                            ],
                            "package": "qiime"
                        }
                    ],
                    "class": "SoftwareRequirement"
                }
            ],
            "stderr": "assign_taxonomy.error",
            "stdout": "assign_taxonomy.out",
            "baseCommand": "assign_taxonomy.py",
            "inputs": [
                {
                    "type": "File",
                    "doc": "fasta file",
                    "inputBinding": {
                        "prefix": "--input_fasta_fp"
                    },
                    "id": "#assign_taxonomy.cwl/fasta"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "doc": "Path to tab-delimited file mapping sequences to\nassigned taxonomy. Each assigned taxonomy is provided\nas a semicolon-separated list. For assignment with\nrdp, each assigned taxonomy must be exactly 6 levels\ndeep. [default: /usr/local/lib/python2.7/dist-packages\n/qiime_default_reference/gg_13_8_otus/taxonomy/97_otu_\ntaxonomy.txt]\n",
                    "inputBinding": {
                        "prefix": "--id_to_taxonomy_fp"
                    },
                    "id": "#assign_taxonomy.cwl/id_to_taxonomy"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "doc": "Path to reference sequences.  For assignment with\nblast, these are used to generate a blast database.\nFor assignment with rdp, they are used as training\nsequences for the classifier. [default:\n/usr/local/lib/python2.7/dist-packages/qiime_default_r\n",
                    "inputBinding": {
                        "prefix": "--reference_seqs_fp"
                    },
                    "id": "#assign_taxonomy.cwl/reference_sequences"
                }
            ],
            "arguments": [
                {
                    "valueFrom": "taxonomy",
                    "prefix": "--output_dir"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "taxonomy/*_rep_set_tax_assignments.txt"
                    },
                    "id": "#assign_taxonomy.cwl/id2taxonomy"
                },
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "taxonomy"
                    },
                    "id": "#assign_taxonomy.cwl/results"
                },
                {
                    "type": "File",
                    "id": "#assign_taxonomy.cwl/stderr",
                    "outputBinding": {
                        "glob": "assign_taxonomy.error"
                    }
                },
                {
                    "type": "File",
                    "id": "#assign_taxonomy.cwl/stdout",
                    "outputBinding": {
                        "glob": "assign_taxonomy.out"
                    }
                }
            ],
            "id": "#assign_taxonomy.cwl",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/copyrightHolder": "n/a"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "coresMax": 1,
                    "ramMin": 1024,
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "mgrast/qiime:1.0.20180919",
                    "class": "DockerRequirement"
                },
                {
                    "packages": [
                        {
                            "specs": [
                                "https://identifiers.org/rrid/RRID:SCR_008249"
                            ],
                            "version": [
                                "1.9.1"
                            ],
                            "package": "qiime"
                        }
                    ],
                    "class": "SoftwareRequirement"
                }
            ],
            "stderr": "beta_diversity_through_plots.error",
            "stdout": "beta_diversity_through_plots.out",
            "baseCommand": "beta_diversity_through_plots.py",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-m"
                    },
                    "id": "#beta_diversity_through_plots.cwl/mapping"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-i"
                    },
                    "id": "#beta_diversity_through_plots.cwl/otu-table"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--tree_fp"
                    },
                    "id": "#beta_diversity_through_plots.cwl/tree"
                }
            ],
            "arguments": [
                {
                    "valueFrom": "beta_diversity",
                    "prefix": "-o"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "beta_diversity"
                    },
                    "id": "#beta_diversity_through_plots.cwl/beta"
                },
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "beta_diversity"
                    },
                    "id": "#beta_diversity_through_plots.cwl/results"
                },
                {
                    "type": "File",
                    "id": "#beta_diversity_through_plots.cwl/stderr",
                    "outputBinding": {
                        "glob": "beta_diversity_through_plots.error"
                    }
                },
                {
                    "type": "File",
                    "id": "#beta_diversity_through_plots.cwl/stdout",
                    "outputBinding": {
                        "glob": "beta_diversity_through_plots.out"
                    }
                }
            ],
            "s:license": "https://www.apache.org/licenses/LICENSE-2.0",
            "s:copyrightHolder": "n/a",
            "id": "#beta_diversity_through_plots.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "coresMax": 1,
                    "ramMin": 1024,
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "mgrast/qiime:1.0.20180919",
                    "class": "DockerRequirement"
                },
                {
                    "packages": [
                        {
                            "specs": [
                                "https://identifiers.org/rrid/RRID:SCR_008249"
                            ],
                            "version": [
                                "1.9.1"
                            ],
                            "package": "qiime"
                        }
                    ],
                    "class": "SoftwareRequirement"
                }
            ],
            "stderr": "filter_otus_from_otu_table.error",
            "stdout": "filter_otus_from_otu_table.out",
            "baseCommand": "filter_otus_from_otu_table.py",
            "inputs": [
                {
                    "type": "int",
                    "default": 0,
                    "inputBinding": {
                        "prefix": "--min_count"
                    },
                    "id": "#filter_otus_from_otu_table.cwl/min_observation_count"
                },
                {
                    "type": "File",
                    "doc": "Input OTU table filepath in BIOM format",
                    "inputBinding": {
                        "prefix": "--input_fp"
                    },
                    "id": "#filter_otus_from_otu_table.cwl/otu-biom-table"
                },
                {
                    "type": "string",
                    "default": "otu-table-filtered.biom",
                    "inputBinding": {
                        "prefix": "--output_fp"
                    },
                    "id": "#filter_otus_from_otu_table.cwl/output"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#filter_otus_from_otu_table.cwl/stderr",
                    "outputBinding": {
                        "glob": "filter_otus_from_otu_table.error"
                    }
                },
                {
                    "type": "File",
                    "id": "#filter_otus_from_otu_table.cwl/stdout",
                    "outputBinding": {
                        "glob": "filter_otus_from_otu_table.out"
                    }
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output)"
                    },
                    "id": "#filter_otus_from_otu_table.cwl/table"
                }
            ],
            "id": "#filter_otus_from_otu_table.cwl",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/copyrightHolder": "n/a"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "coresMax": 1,
                    "ramMin": 1024,
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "mgrast/qiime:1.0.20180919",
                    "class": "DockerRequirement"
                },
                {
                    "packages": [
                        {
                            "specs": [
                                "https://identifiers.org/rrid/RRID:SCR_008249"
                            ],
                            "version": [
                                "1.9.1"
                            ],
                            "package": "qiime"
                        }
                    ],
                    "class": "SoftwareRequirement"
                }
            ],
            "stderr": "filter_samples_from_otu_table.error",
            "stdout": "filter_samples_from_otu_table.out",
            "baseCommand": "filter_samples_from_otu_table.py",
            "inputs": [
                {
                    "type": "int",
                    "default": 1000,
                    "inputBinding": {
                        "prefix": "--min_count"
                    },
                    "id": "#filter_samples_from_otu_table.cwl/min_observation_count"
                },
                {
                    "type": "File",
                    "doc": "Input OTU table filepath in BIOM format",
                    "inputBinding": {
                        "prefix": "--input_fp"
                    },
                    "id": "#filter_samples_from_otu_table.cwl/otu-biom-table"
                },
                {
                    "type": "string",
                    "default": "otu-table-filtered-samples.biom",
                    "inputBinding": {
                        "prefix": "--output_fp"
                    },
                    "id": "#filter_samples_from_otu_table.cwl/output"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#filter_samples_from_otu_table.cwl/stderr",
                    "outputBinding": {
                        "glob": "filter_samples_from_otu_table.error"
                    }
                },
                {
                    "type": "File",
                    "id": "#filter_samples_from_otu_table.cwl/stdout",
                    "outputBinding": {
                        "glob": "filter_samples_from_otu_table.out"
                    }
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output)"
                    },
                    "id": "#filter_samples_from_otu_table.cwl/table"
                }
            ],
            "id": "#filter_samples_from_otu_table.cwl",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/copyrightHolder": "n/a"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "coresMax": 1,
                    "ramMin": 1024,
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "mgrast/qiime:1.0.20180919",
                    "class": "DockerRequirement"
                },
                {
                    "packages": [
                        {
                            "specs": [
                                "https://identifiers.org/rrid/RRID:SCR_008249"
                            ],
                            "version": [
                                "1.9.1"
                            ],
                            "package": "qiime"
                        }
                    ],
                    "class": "SoftwareRequirement"
                }
            ],
            "stderr": "make_otu_table.error",
            "stdout": "make_otu_table.out",
            "baseCommand": "make_otu_table.py",
            "inputs": [
                {
                    "type": "File",
                    "doc": "cluster ID to sequence IDs mapping, two column",
                    "inputBinding": {
                        "prefix": "--otu_map_fp"
                    },
                    "id": "#make_otu_table.cwl/otu-mapping"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--taxonomy"
                    },
                    "id": "#make_otu_table.cwl/taxonomy-assignment"
                }
            ],
            "arguments": [
                {
                    "valueFrom": "otu_table.biom",
                    "prefix": "--output_biom_fp"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#make_otu_table.cwl/stderr",
                    "outputBinding": {
                        "glob": "make_otu_table.error"
                    }
                },
                {
                    "type": "File",
                    "id": "#make_otu_table.cwl/stdout",
                    "outputBinding": {
                        "glob": "make_otu_table.out"
                    }
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "otu_table.biom"
                    },
                    "id": "#make_otu_table.cwl/table"
                }
            ],
            "id": "#make_otu_table.cwl",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/copyrightHolder": "n/a"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "coresMax": 1,
                    "ramMin": 4096,
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "mgrast/qiime:1.0.20180919",
                    "class": "DockerRequirement"
                },
                {
                    "packages": [
                        {
                            "specs": [
                                "https://identifiers.org/rrid/RRID:SCR_008249"
                            ],
                            "version": [
                                "1.9.1"
                            ],
                            "package": "qiime"
                        }
                    ],
                    "class": "SoftwareRequirement"
                }
            ],
            "stderr": "pick_de_novo_otus.error",
            "stdout": "pick_de_novo_otus.out",
            "baseCommand": "pick_de_novo_otus.py",
            "inputs": [
                {
                    "type": "File",
                    "doc": "fasta file",
                    "inputBinding": {
                        "prefix": "--input_fp"
                    },
                    "id": "#pick_de_novo_otus.cwl/fasta"
                }
            ],
            "arguments": [
                {
                    "valueFrom": "otus",
                    "prefix": "--output_dir"
                },
                "--force"
            ],
            "outputs": [
                {
                    "type": {
                        "type": "record",
                        "fields": [
                            {
                                "type": "File",
                                "outputBinding": {
                                    "glob": "otus/rep_set/*_rep_set.fasta"
                                },
                                "name": "#pick_de_novo_otus.cwl/representative_set/fasta"
                            },
                            {
                                "type": "File",
                                "outputBinding": {
                                    "glob": "otus/rep_set.tre"
                                },
                                "name": "#pick_de_novo_otus.cwl/representative_set/tree"
                            }
                        ]
                    },
                    "id": "#pick_de_novo_otus.cwl/representative_set"
                },
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "otus"
                    },
                    "id": "#pick_de_novo_otus.cwl/results"
                },
                {
                    "type": "File",
                    "id": "#pick_de_novo_otus.cwl/stderr",
                    "outputBinding": {
                        "glob": "pick_de_novo_otus.error"
                    }
                },
                {
                    "type": "File",
                    "id": "#pick_de_novo_otus.cwl/stdout",
                    "outputBinding": {
                        "glob": "pick_de_novo_otus.out"
                    }
                },
                {
                    "type": {
                        "type": "record",
                        "name": "#pick_de_novo_otus.cwl/uclust/uclust",
                        "fields": [
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "outputBinding": {
                                    "glob": "otus/uclust_picked_otus/*_clusters.uc"
                                },
                                "name": "#pick_de_novo_otus.cwl/uclust/uclust/cluster"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "outputBinding": {
                                    "glob": "otus/uclust_picked_otus/*_otus.txt"
                                },
                                "name": "#pick_de_novo_otus.cwl/uclust/uclust/otus"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "outputBinding": {
                                    "glob": "otus/uclust_assigned_taxonomy/*_rep_set_tax_assignments.txt"
                                },
                                "name": "#pick_de_novo_otus.cwl/uclust/uclust/taxonomy"
                            }
                        ]
                    },
                    "id": "#pick_de_novo_otus.cwl/uclust"
                }
            ],
            "id": "#pick_de_novo_otus.cwl",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/copyrightHolder": "n/a"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "coresMax": 1,
                    "ramMin": 1024,
                    "class": "ResourceRequirement"
                },
                {
                    "types": [
                        {
                            "type": "enum",
                            "name": "#plot_taxa_summary.cwl/level-type",
                            "symbols": [
                                "#plot_taxa_summary.cwl/level-type/Domain",
                                "#plot_taxa_summary.cwl/level-type/Phylum",
                                "#plot_taxa_summary.cwl/level-type/Class",
                                "#plot_taxa_summary.cwl/level-type/Order",
                                "#plot_taxa_summary.cwl/level-type/Family",
                                "#plot_taxa_summary.cwl/level-type/Genus",
                                "#plot_taxa_summary.cwl/level-type/Species"
                            ]
                        }
                    ],
                    "class": "SchemaDefRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "mgrast/qiime:1.0.20180919",
                    "class": "DockerRequirement"
                },
                {
                    "packages": [
                        {
                            "specs": [
                                "https://identifiers.org/rrid/RRID:SCR_008249"
                            ],
                            "version": [
                                "1.9.1"
                            ],
                            "package": "qiime"
                        }
                    ],
                    "class": "SoftwareRequirement"
                }
            ],
            "stderr": "plot_taxa_summary.error",
            "stdout": "plot_taxa_summary.out",
            "baseCommand": "plot_taxa_summary.py",
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "#plot_taxa_summary.cwl/level-type"
                        }
                    ],
                    "default": "null",
                    "doc": "Comma-separated list of taxonomic levels (e.g.\nPhylum,Class,Order)  [default=none]\n",
                    "inputBinding": {
                        "prefix": "--labels",
                        "itemSeparator": ","
                    },
                    "id": "#plot_taxa_summary.cwl/labels"
                },
                {
                    "type": "string",
                    "default": "./taxa-summary-plots",
                    "inputBinding": {
                        "prefix": "--dir_path"
                    },
                    "id": "#plot_taxa_summary.cwl/output"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "doc": "summarized taxa",
                    "inputBinding": {
                        "prefix": "--counts_fname",
                        "itemSeparator": ",",
                        "valueFrom": "${ \n    self.forEach( function(element) {\n                                var res = element.path.match(/_L(\\d+)/);\n                                element.pos = res[1]\n                            } );\n    return self.sort(function(a,b){ return a.pos - b.pos } )\n}\n"
                    },
                    "id": "#plot_taxa_summary.cwl/taxa-counts-files"
                }
            ],
            "arguments": [
                "-s",
                {
                    "prefix": "--chart_type",
                    "valueFrom": "pie,area,bar"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        "Directory"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.output)"
                    },
                    "id": "#plot_taxa_summary.cwl/results"
                },
                {
                    "type": "File",
                    "id": "#plot_taxa_summary.cwl/stderr",
                    "outputBinding": {
                        "glob": "plot_taxa_summary.error"
                    }
                },
                {
                    "type": "File",
                    "id": "#plot_taxa_summary.cwl/stdout",
                    "outputBinding": {
                        "glob": "plot_taxa_summary.out"
                    }
                }
            ],
            "id": "#plot_taxa_summary.cwl",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/copyrightHolder": "n/a"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "coresMax": 1,
                    "ramMin": 1024,
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "mgrast/qiime:1.0.20180919",
                    "class": "DockerRequirement"
                },
                {
                    "packages": [
                        {
                            "specs": [
                                "https://identifiers.org/rrid/RRID:SCR_008249"
                            ],
                            "version": [
                                "1.9.1"
                            ],
                            "package": "qiime"
                        }
                    ],
                    "class": "SoftwareRequirement"
                }
            ],
            "stderr": "sort_otu_table.error",
            "stdout": "sort_otu_table.out",
            "baseCommand": "sort_otu_table.py",
            "inputs": [
                {
                    "type": "File",
                    "doc": "Input OTU table filepath in BIOM format",
                    "inputBinding": {
                        "prefix": "--input_otu_table"
                    },
                    "id": "#sort_otu_table.cwl/otu-biom-table"
                },
                {
                    "type": "string",
                    "default": "otu-table-sorted.biom",
                    "inputBinding": {
                        "prefix": "--output"
                    },
                    "id": "#sort_otu_table.cwl/output"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--sorted_sample_ids_fp"
                    },
                    "id": "#sort_otu_table.cwl/sorted-sample-ids"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#sort_otu_table.cwl/stderr",
                    "outputBinding": {
                        "glob": "sort_otu_table.error"
                    }
                },
                {
                    "type": "File",
                    "id": "#sort_otu_table.cwl/stdout",
                    "outputBinding": {
                        "glob": "sort_otu_table.out"
                    }
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output)"
                    },
                    "id": "#sort_otu_table.cwl/table"
                }
            ],
            "id": "#sort_otu_table.cwl",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/copyrightHolder": "n/a"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "coresMax": 1,
                    "ramMin": 1024,
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "mgrast/qiime:1.0.20180919",
                    "class": "DockerRequirement"
                },
                {
                    "packages": [
                        {
                            "specs": [
                                "https://identifiers.org/rrid/RRID:SCR_008249"
                            ],
                            "version": [
                                "1.9.1"
                            ],
                            "package": "qiime"
                        }
                    ],
                    "class": "SoftwareRequirement"
                }
            ],
            "stderr": "summarize_taxa.error",
            "stdout": "summarize_taxa.out",
            "baseCommand": "summarize_taxa.py",
            "inputs": [
                {
                    "type": "File",
                    "doc": "Input OTU table filepath",
                    "inputBinding": {
                        "prefix": "--otu_table_fp"
                    },
                    "id": "#summarize_taxa.cwl/otu-table"
                },
                {
                    "type": "string",
                    "default": "./summarize_taxa",
                    "inputBinding": {
                        "prefix": "--output_dir"
                    },
                    "id": "#summarize_taxa.cwl/output"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "prefix": "--absolute_abundance"
                    },
                    "id": "#summarize_taxa.cwl/report-absolute-abundance"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "default": [
                        2,
                        3,
                        4,
                        5,
                        6,
                        7
                    ],
                    "inputBinding": {
                        "prefix": "--level",
                        "itemSeparator": ","
                    },
                    "id": "#summarize_taxa.cwl/taxonomic-level"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.output)/*.biom"
                    },
                    "id": "#summarize_taxa.cwl/biom"
                },
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.output)"
                    },
                    "id": "#summarize_taxa.cwl/results"
                },
                {
                    "type": "File",
                    "id": "#summarize_taxa.cwl/stderr",
                    "outputBinding": {
                        "glob": "summarize_taxa.error"
                    }
                },
                {
                    "type": "File",
                    "id": "#summarize_taxa.cwl/stdout",
                    "outputBinding": {
                        "glob": "summarize_taxa.out"
                    }
                },
                {
                    "type": {
                        "type": "array",
                        "items": [
                            "File",
                            "null"
                        ]
                    },
                    "outputBinding": {
                        "glob": "$(inputs.output)/*.txt"
                    },
                    "id": "#summarize_taxa.cwl/txt"
                }
            ],
            "id": "#summarize_taxa.cwl",
            "http://schema.org/license": "https://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/copyrightHolder": "n/a"
        },
        {
            "class": "Workflow",
            "label": "fasta2taxa-plot",
            "doc": "Input is a fasta file with n>1 samples, with sample id as sequence identifier prefix, and a sample id file.\nThe workflow calls open otus and assigns taxa using greengenes. The output are taxa plots. \n",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "coresMax": 1,
                    "ramMin": 1024,
                    "class": "ResourceRequirement"
                },
                {
                    "types": [
                        {
                            "type": "enum",
                            "name": "#main/level-type",
                            "symbols": [
                                "#main/level-type/Domain",
                                "#main/level-type/Phylum",
                                "#main/level-type/Class",
                                "#main/level-type/Order",
                                "#main/level-type/Family",
                                "#main/level-type/Genus",
                                "#main/level-type/Species"
                            ]
                        }
                    ],
                    "class": "SchemaDefRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "hints": [
                {
                    "packages": [
                        {
                            "specs": [
                                "https://identifiers.org/rrid/RRID:SCR_008249"
                            ],
                            "version": [
                                "1.9.1"
                            ],
                            "package": "qiime"
                        }
                    ],
                    "class": "SoftwareRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/fasta-demultiplexed"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/min-observations-per-otu"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/min-observations-per-sample"
                },
                {
                    "type": "File",
                    "id": "#main/sample-mapping"
                },
                {
                    "type": {
                        "type": "record",
                        "fields": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": "#main/level-type"
                                },
                                "name": "#main/summarize-for-taxonomic-levels/labels"
                            },
                            {
                                "type": {
                                    "type": "array",
                                    "items": "int"
                                },
                                "name": "#main/summarize-for-taxonomic-levels/numeric"
                            }
                        ]
                    },
                    "id": "#main/summarize-for-taxonomic-levels"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/alpha-diversity/alpha",
                    "id": "#main/aplha-diversity-results"
                },
                {
                    "type": "Directory",
                    "outputSource": "#main/beta-diversity/results",
                    "id": "#main/beta-diversity-results"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "doc": "Error logs for each step, collected by default and can be empty.",
                    "outputSource": [
                        "#main/cluster/stderr",
                        "#main/taxonomy/stderr",
                        "#main/otu-table/stderr",
                        "#main/sort-table/stderr",
                        "#main/filter-otus/stderr",
                        "#main/summarize-taxa/stderr",
                        "#main/plot-taxa-summary/stderr",
                        "#main/alpha-diversity/stderr",
                        "#main/beta-diversity/stderr"
                    ],
                    "id": "#main/error-logs"
                },
                {
                    "type": {
                        "type": "array",
                        "items": [
                            "File",
                            "Directory"
                        ]
                    },
                    "outputSource": [
                        "#main/cluster/results",
                        "#main/taxonomy/id2taxonomy",
                        "#main/taxonomy/results",
                        "#main/otu-table/table",
                        "#main/sort-table/table",
                        "#main/filter-otus/table",
                        "#main/summarize-taxa/results"
                    ],
                    "id": "#main/results"
                },
                {
                    "type": "Directory",
                    "outputSource": [
                        "#main/plot-taxa-summary/results"
                    ],
                    "id": "#main/taxa-summary-plots"
                }
            ],
            "steps": [
                {
                    "label": "alpha diversity",
                    "run": "#alpha_diversity.cwl",
                    "in": [
                        {
                            "default": [
                                "chao1",
                                "PD_whole_tree",
                                "shannon",
                                "observed_otus"
                            ],
                            "id": "#main/alpha-diversity/method"
                        },
                        {
                            "source": "#main/filter-samples/table",
                            "id": "#main/alpha-diversity/otu-table"
                        },
                        {
                            "source": "#main/cluster/representative_set",
                            "valueFrom": "$(self.tree)",
                            "id": "#main/alpha-diversity/tree"
                        }
                    ],
                    "out": [
                        "#main/alpha-diversity/stderr",
                        "#main/alpha-diversity/alpha"
                    ],
                    "id": "#main/alpha-diversity"
                },
                {
                    "label": "beta diversity",
                    "run": "#beta_diversity_through_plots.cwl",
                    "in": [
                        {
                            "source": "#main/sample-mapping",
                            "id": "#main/beta-diversity/mapping"
                        },
                        {
                            "source": "#main/filter-samples/table",
                            "id": "#main/beta-diversity/otu-table"
                        },
                        {
                            "source": "#main/cluster/representative_set",
                            "valueFrom": "$(self.tree)",
                            "id": "#main/beta-diversity/tree"
                        }
                    ],
                    "out": [
                        "#main/beta-diversity/stderr",
                        "#main/beta-diversity/beta",
                        "#main/beta-diversity/results"
                    ],
                    "id": "#main/beta-diversity"
                },
                {
                    "label": "pick de novo otus",
                    "run": "#pick_de_novo_otus.cwl",
                    "in": [
                        {
                            "source": "#main/fasta-demultiplexed",
                            "id": "#main/cluster/fasta"
                        }
                    ],
                    "out": [
                        "#main/cluster/results",
                        "#main/cluster/uclust",
                        "#main/cluster/representative_set",
                        "#main/cluster/stderr"
                    ],
                    "id": "#main/cluster"
                },
                {
                    "label": "remove singletons",
                    "run": "#filter_otus_from_otu_table.cwl",
                    "in": [
                        {
                            "source": "#main/min-observations-per-otu",
                            "default": 2,
                            "id": "#main/filter-otus/min_observation_count"
                        },
                        {
                            "source": "#main/sort-table/table",
                            "id": "#main/filter-otus/otu-biom-table"
                        }
                    ],
                    "out": [
                        "#main/filter-otus/stderr",
                        "#main/filter-otus/table"
                    ],
                    "id": "#main/filter-otus"
                },
                {
                    "label": "remove samples with low coverage",
                    "run": "#filter_samples_from_otu_table.cwl",
                    "in": [
                        {
                            "source": "#main/min-observations-per-sample",
                            "default": 100,
                            "id": "#main/filter-samples/min_observation_count"
                        },
                        {
                            "source": "#main/filter-otus/table",
                            "id": "#main/filter-samples/otu-biom-table"
                        }
                    ],
                    "out": [
                        "#main/filter-samples/stderr",
                        "#main/filter-samples/table"
                    ],
                    "id": "#main/filter-samples"
                },
                {
                    "label": "make out table",
                    "run": "#make_otu_table.cwl",
                    "in": [
                        {
                            "source": "#main/cluster/uclust",
                            "valueFrom": "$(self.otus)",
                            "id": "#main/otu-table/otu-mapping"
                        },
                        {
                            "source": "#main/taxonomy/id2taxonomy",
                            "id": "#main/otu-table/taxonomy-assignment"
                        }
                    ],
                    "out": [
                        "#main/otu-table/stderr",
                        "#main/otu-table/table"
                    ],
                    "id": "#main/otu-table"
                },
                {
                    "label": "plot summaries",
                    "run": "#plot_taxa_summary.cwl",
                    "in": [
                        {
                            "source": "#main/summarize-for-taxonomic-levels",
                            "valueFrom": "$(self.labels)",
                            "id": "#main/plot-taxa-summary/labels"
                        },
                        {
                            "source": "#main/summarize-taxa/txt",
                            "valueFrom": "${ \n    self.forEach( element => {\n                                var res = element.location.match(/_L(\\d+)/);\n                                element.pos = res[1]\n                } );\n    return self.sort(function(a,b){ return a.pos - b.pos } )\n}\n",
                            "id": "#main/plot-taxa-summary/taxa-counts-files"
                        }
                    ],
                    "out": [
                        "#main/plot-taxa-summary/stderr",
                        "#main/plot-taxa-summary/results"
                    ],
                    "id": "#main/plot-taxa-summary"
                },
                {
                    "label": "sort otu table by samples",
                    "run": "#sort_otu_table.cwl",
                    "in": [
                        {
                            "source": "#main/otu-table/table",
                            "id": "#main/sort-table/otu-biom-table"
                        },
                        {
                            "source": "#main/sample-mapping",
                            "id": "#main/sort-table/sorted-sample-ids"
                        }
                    ],
                    "out": [
                        "#main/sort-table/stderr",
                        "#main/sort-table/table"
                    ],
                    "id": "#main/sort-table"
                },
                {
                    "label": "list taxonomic levels",
                    "run": "#summarize_taxa.cwl",
                    "in": [
                        {
                            "source": "#main/filter-samples/table",
                            "id": "#main/summarize-taxa/otu-table"
                        },
                        {
                            "source": "#main/summarize-for-taxonomic-levels",
                            "valueFrom": "$(self.numeric)",
                            "id": "#main/summarize-taxa/taxonomic-level"
                        }
                    ],
                    "out": [
                        "#main/summarize-taxa/stderr",
                        "#main/summarize-taxa/results",
                        "#main/summarize-taxa/biom",
                        "#main/summarize-taxa/txt"
                    ],
                    "id": "#main/summarize-taxa"
                },
                {
                    "label": "assign taxonomy",
                    "run": "#assign_taxonomy.cwl",
                    "in": [
                        {
                            "source": "#main/cluster/representative_set",
                            "valueFrom": "$(self.fasta)",
                            "id": "#main/taxonomy/fasta"
                        }
                    ],
                    "out": [
                        "#main/taxonomy/stderr",
                        "#main/taxonomy/results",
                        "#main/taxonomy/id2taxonomy"
                    ],
                    "id": "#main/taxonomy"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0",
    "$schemas": [
        "http://edamontology.org/EDAM_1.16.owl",
        "https://schema.org/docs/schema_org_rdfa.html"
    ]
}
